module numbertheory

  implicit none

contains

  function gcd(a, b) ! Greatest Common Divisor
    integer :: gcd
    integer, intent(in) :: a, b
    integer :: gb, t

    gcd = a
    gb = b

    do
      t = mod(gcd, gb)
      gcd = gb
      if (t == 0) exit
      gb = t
    end do

  end function gcd

  function lcm(a, b) ! Least Common Multiple
    integer :: lcm
    integer, intent(in) :: a, b

    lcm = a*b/gcd(a,b)

  end function lcm

end module numbertheory
