program sieve
 
  implicit none
  integer, parameter :: i_max = 100
  integer :: i,j
  logical, dimension (i_max) :: is_prime
 
  is_prime = .true.
  is_prime (1) = .false.
  do i = 2, int (sqrt (real (i_max)))
    if (is_prime (i)) then 
      do j= i*i, i_max, i
         is_prime (j) = .false.
      end do
    end if
  end do
  do i = 1, i_max
    if (is_prime (i)) write (*, '(i0, 1x)', advance = 'no') i
  end do
  write (*, *)
 
end program sieve
